//#import "mso9.dll" no_namespace rename("DocumentProperties", "DocumentPropertiesXL") rename("RGB", "RBGXL")
//#import "vbe6ext.olb" no_namespace rename("_Windows", "_WindowsXL")
//#import "C:\\Program Files (x86)\\Microsoft Office\\root\\Office16\\EXCEL.exe" rename("DialogBox", "DialogBoxXL") rename("RGB", "RBGXL") \
//    rename("DocumentProperties", "DocumentPropertiesXL") rename("CopyFile", "CopyFileXL") rename("ReplaceText", "ReplaceTextXL") 
  
// cl /EHsc excelcom.cpp

#include "mso9.tlh"
#include "vbe6ext.tlh"
#include "excel9.tlh"

#include <iostream>

using namespace std;

void DisplayComError(const _com_error& e) {
        cout << "Com Exception:" << endl;
        cout << "\tCode = " << e.Error() << endl;
         cout << "\tCode meaning = " << e.ErrorMessage() << endl;
 		    _bstr_t bstrSource(e.Source());
     if (!bstrSource) {} else {
		    cout << "\tSource = " << (LPCTSTR) bstrSource << endl;
	  }
         _bstr_t bstrDescription(e.Description());
      if (!bstrDescription) {} else {
		   cout << "\tDescription = " << (LPCTSTR) bstrDescription << endl;
	   }
}

static char* convert(_bstr_t text) {
    char* str = 0;
    size_t length = strlen((const char*)text);
    str = new char[length+1];
    strncpy(str, (const char*)text, length);
    str[length] = '\0';
    return str;
  }


int main(int argc, char* argv[]) {
    CoInitializeEx(0, COINITBASE_MULTITHREADED);
    Excel::_ApplicationPtr pXL;
    try {
    HRESULT hr = pXL.CreateInstance(L"Excel.Application");
	if(FAILED(hr)) {
		cout << "Error opening Excel COM: " << hr << endl;
		throw std::runtime_error("Error Opening Excel");
	}
    cout << "Created Excel application" << endl;
    Excel::WorkbooksPtr books = pXL->Workbooks;
    // argv[1] must be full path as we are loading from Excel, not current directory
    Excel::_WorkbookPtr book = books->Open(argv[1], 0);
    cout << "Opened " << argv[1] << endl;
	cout << book->Name << endl;
    pXL->PutVisible(0, FALSE);
    Excel::_WorksheetPtr aSheet = pXL->ActiveSheet;
	
    cout << "Active sheet is \"" << aSheet->Name << "\"" << endl;
    //Excel::RangePtr pRange = pSheet->Cells;
    Excel::RangePtr pRange = pXL->GetRange(L"'gas data'!A2:A4");
    cout << "Accessed \"gas data\" ranges" << endl;
    cout << "Reading first row" << endl;

    Excel::WorksheetFunctionPtr func;
	int num = 0;
	
	for (int t = 0; t < 15; ++t) {
		try {
			cout << "Tentative " << t << endl;
			func = pXL->GetWorksheetFunction();
			break; // no exception
		} catch( _com_error& err ) {
			Sleep(300);
			if (t == 14) {
				throw;
			}
		}
	}	
	
    // Excel ranges start at 1
    for (int idx = 1; idx < 6; ++idx) {
        _variant_t content = pRange->Item[2][idx];
        if(func->IsNumber(content) == VARIANT_TRUE)
          cout << "num: " << (double)content << endl;
        else if (func->IsText(content) == VARIANT_TRUE) {
            _bstr_t result(content);
          cout << "str: " << (const char*)convert(result) << endl;
        }
    }
    // now write, crashes if sheet does not exists
    // TODO : parse and create the sheet if it does not exists
    //    Excel::_WorksheetPtr newsheet = book->Worksheets->Add();
   //   newsheet->Name = "NewSheet";
   //   cout << "Created new sheet" << endl;

    Excel::RangePtr wRange = pXL->GetRange(L"RESULT!A2:A4");
    cout << "accessed writing sheet \"result\"" << endl;
    wRange->Item[2][2] = 1234;
    wRange->Item[2][3] = 7890;
    cout << "Succeeded writing to sheet" << endl;

    pXL->PutDisplayAlerts(LOCALE_USER_DEFAULT, VARIANT_FALSE);
	
	// FIX !
	book = aSheet->Parent;
	
	cout << "real name " << book->Name << endl;
	book->Save();
	cout << "Saved " << endl;
	book->Close(vtMissing, vtMissing, vtMissing, 0);
	cout << "Closed" << endl;
	} catch(const _com_error& e) {
		DisplayComError(e);
	} 
    pXL->Quit();
    cout << "Quit" << endl;
    CoUninitialize();
    return 0;
}
